import greenfoot.Actor;
import greenfoot.World;

import java.util.List;

/**
 * Repraesentation von Mauern im Java-Hamster-Modell
 * 
 * @author Dietrich Boles (Universitaet Oldenburg)
 * @version 2.0 (10.12.2010)
 * 
 */
public class Mauer extends Actor {

	public Mauer() {
        setImage("mauer.png");
	}

	protected void addedToWorld(World world) {
	   if (getWorld().getObjectsAt(getX(), getY(), Mauer.class).size() > 1 ||
	       getWorld().getObjectsAt(getX(), getY(), Hamster.class).size() > 0
	      ) {
	       getWorld().removeObject(this);
	   } else {
	       removeGrainsOnCell(getX(), getY());
	   }
	}
	
	public void setLocation(int x, int y) {
	    if (getX() == x && getY() == y || !allowed(x, y)) {
	        return;
	    }
	    removeGrainsOnCell(x, y);
	    super.setLocation(x, y);
	}
	
	private boolean allowed(int x, int y) {
	    if (getX() == x && getY() == y) {
	        return false;
	    }
	    if (getWorld().getObjectsAt(x, y, Mauer.class).size() > 0) {
	        return false;
	    }
	    if (getWorld().getObjectsAt(x, y, Hamster.class).size() > 0) {
	        return false;
	    }
	    return true;
	}
	
	private void removeGrainsOnCell(int x, int y) {
	    getWorld().removeObjects(getWorld().getObjectsAt(x, y, Korn.class));
	}
}